/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.*;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.TreeMap;

import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;
import javax.swing.event.*;
import javax.swing.plaf.synth.SynthLookAndFeel;
import javax.swing.tree.TreePath;

/**
 * mainNX.
 * @author Yuu
 * @version 14.00
 * @since 2016-12
 */
public class ConfigDialog extends JDialog {

	/** gqtB^ݒNX̕ϐ. */
	ArrayList<String> arExFilter = FileExtensionInitFilter.extensionArry;

	/** ZbgAbvt@C. */
	Setup setup;

	/******************* gq^u ********************/
	/** gqݒPanel. */
	private JPanel panelExtension;
	/** gq^uʂŎgp郉x. */
	private JLabel lbExtensionNameAll,lbExtensionNameText;
   /** gq̓tB[h. */
	private JTextField txtExtension;
	/** gq\List. */
	private JList lstExtension;
	/** gqList\f[^. */
	public DefaultListModel<String> model;
	/** gqListɒǉ{^. */
	private JButton btnTuikaH;
	/** Listɕ\Ăgq폜{^. */
	private JButton btnDell;
	/** C. */
	private LineBorder linborderK;

	/******************* @^u ********************/
	/** @ύXPanel. */
	private JPanel panelSearch;
	/** C. */
	private LineBorder linborderSearch;
	/** @IWI{^.  */
	private JRadioButton[] rdoS;
	/** @ۑ. */
	public static String strSearch = "K\";
	/** ӏ(@). */
	public JLabel warmLbl;

	/******************* Oσ^u ********************/
	/** OσfUCύXPanel. */
	private JPanel panelDesin;
	/** C. */
	private LineBorder linborderG;
	/** OϕύXWI{^. */
	private JRadioButton[] rdoG;
	/** ӏ(Oϐݒ). */
	public JLabel warmGLbl;

	/******************* (OKALZ{^) ********************/
	/** OKALZ{^zuPanel. */
	private JPanel panelBtn;
	/** OK{^ */
	private JButton btnOK;
	/** LZ{^ */
	private JButton btnCancel;


	/** ^u. */
	JTabbedPane tp;

	/** LZ{^. */
	boolean canceld = false;

	/** CAEg. */
	GridBagLayout layout;
	/** gridx ͉@gridy͏c. */
	GridBagConstraints gbclayout;

	static SearchApp searApp;

	/**
	 * @param frame
	 */
	public ConfigDialog(JFrame frame){
	   super(frame, " ݒ ", true);

	   searApp = (SearchApp) frame;

	   Container con = getContentPane();

	   panelDesin = new JPanel();
	   panelExtension = new JPanel();
	   panelSearch = new JPanel();

	   panelBtn = new JPanel();
	   btnOK = new JButton("@O@K@");
	   btnCancel = new JButton("LZ");

	   FlowLayout layoutBtn = new FlowLayout();
	   layoutBtn.setAlignment(FlowLayout.RIGHT);
	   panelBtn.setLayout(layoutBtn);
	   panelBtn.add(btnOK);
	   panelBtn.add(btnCancel);

		/***********************************************************/
		/*      gq^u                                                                                            */
		/***********************************************************/
	   linborderK = new LineBorder(Color.lightGray, 1,true);
	   TitledBorder borderK =
	     new TitledBorder(linborderK, "gq", TitledBorder.LEFT, TitledBorder.TOP);

	   panelExtension.setPreferredSize(new Dimension(350,400));
	   panelExtension.setBorder(borderK);
	   tp = new JTabbedPane();

	   tp.addTab("gq",panelExtension);

	   btnDell = new JButton("폜");
	   btnTuikaH = new JButton("ǉ");
	   lbExtensionNameAll = new JLabel("Ȃgq");
	   lbExtensionNameAll.setOpaque(true);
	   lbExtensionNameText = new JLabel("gq");
	   lbExtensionNameText.setOpaque(true);

	   txtExtension =  new JTextField();
	   txtExtension.setToolTipText("<html>u.vtċLĂB</html>");

	    model = new DefaultListModel();
		/* gqtB^ۑ */
//		for (int i =0; i < arExFilter.size(); i++) {
//			System.out.println(arExFilter.get(i));
//			model.addElement(arExFilter.get(i));
//		}
//		System.out.println(arExFilter.get(0));
//		model.addElement("eXg");
	   lstExtension = new JList(model);

	    lstExtension.setLayoutOrientation(JList.VERTICAL);
	    lstExtension.setFixedCellWidth(60);
	    lstExtension.setFixedCellHeight(20);

	    JScrollPane sp = new JScrollPane();
	    sp.getViewport().setView(lstExtension);
	    sp.setPreferredSize(new Dimension(200, 150));

		layout = new GridBagLayout();
		gbclayout = new GridBagConstraints();

		this.setLayout(new BorderLayout());

		/** ̓tB[hzupl̃CAEg */
		panelExtension.setLayout(layout);

		/**                                                                                           *
		 * JLabel̔zuʒu@ugqvx(0,0)                             *
		 *                                                                                              */
		gbclayout.gridx = 0;
		gbclayout.gridy = 0;
		/** JLabel̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.insets = new Insets(2,4,3,4);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.WEST;
		layout.setConstraints(lbExtensionNameAll, gbclayout);

		/**                                                                                           *
		 * JList̔zuʒu@ugq̃XgvXg(0,1)                   *
		 *                                                                                             */
		gbclayout.gridx = 0;
		gbclayout.gridy = 1;
		/** */
		gbclayout.gridheight = 3;
		gbclayout.gridwidth = 4;

		gbclayout.insets = new Insets(4,4,3,4);
		gbclayout.fill = GridBagConstraints.BOTH;
		gbclayout.anchor = GridBagConstraints.CENTER;
		layout.setConstraints(sp, gbclayout);

		/**                                                                                           *
		 * btnDell̔zuʒu@ugq폜{^v{^(0,4)           *
		 *                                                                                              */
		gbclayout.gridx = 0;
		gbclayout.gridy = 4;
		/** JLabel̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.insets = new Insets(4,4,3,10);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.WEST;
		layout.setConstraints(btnDell, gbclayout);

		/**                                                                                           *
		 * JLabel̔zuʒu@ugq́vx(0,5)                   *
		 *                                                                                              */
		gbclayout.gridx = 0;
		gbclayout.gridy = 5;
		/** JLabel̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.insets = new Insets(10,4,3,4);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.WEST;
		layout.setConstraints(lbExtensionNameText, gbclayout);

		/**                                                                                           *
		 * JText̔zuʒu@ugq́veLXgtB[h(0,6)     *
		 *                                                                                              */
		gbclayout.gridx = 0;
		gbclayout.gridy = 6;
		/** JLabel̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 4;

		gbclayout.insets = new Insets(4,4,3,10);
		gbclayout.fill = GridBagConstraints.HORIZONTAL;
		gbclayout.anchor = GridBagConstraints.WEST;
		layout.setConstraints(txtExtension, gbclayout);

		/**                                                                                           *
		 * btnTuika̔zuʒu@ugqǉ{^v{^(0,7)         *
		 *                                                                                              */
		gbclayout.gridx = 0;
		gbclayout.gridy = 7;
		/** JLabel̔zuZ */
		gbclayout.gridheight = 1;
		gbclayout.gridwidth = 1;

		gbclayout.insets = new Insets(4,4,10,10);
		gbclayout.fill = GridBagConstraints.NONE;
		gbclayout.anchor = GridBagConstraints.WEST;
		layout.setConstraints(btnTuikaH, gbclayout);

		panelExtension.add(lbExtensionNameAll);
		panelExtension.add(sp);
		panelExtension.add(btnDell);
		panelExtension.add(lbExtensionNameText);
		panelExtension.add(txtExtension);
		panelExtension.add(btnTuikaH);

		this.add(tp,BorderLayout.CENTER);
		this.add(panelBtn,BorderLayout.SOUTH);

		/** ListőI΂ꂽgqҏWeLXg{bNX. */
		lstExtension.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				int c =  e.getClickCount();
			      if (!lstExtension.isSelectionEmpty()) {
			    	  if (c == 1) {
			    		  //gq͂̃eLXg{bNXNA
			    		  txtExtension.setText("");
			    		  btnTuikaH.setText("ǉ");
			    		  btnDell.setEnabled(true);
			    	  } else if (c == 2) {
			    		  //Iꂽgq𓾂
			    		  String strname = (String)lstExtension.getSelectedValue();
			    		  txtExtension.setText(strname);
			    		  btnTuikaH.setText("ҏW");
			    		  btnDell.setEnabled(false);
			    	  }
			      }
			}
		});

	   /*폜{^*/
		btnDell.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e){
		      if (!lstExtension.isSelectionEmpty()) {
		          int index = lstExtension.getSelectedIndex();
		          model.remove(index);
		        } else {
					SearchApp.showMessage("폜gqIĂB");
		        }
		}
	   });

		   /*ǉAҏW{^*/
		btnTuikaH.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e){

				//gq̓`FbN
				if(  extentionCheck() ) {
					return;
				}

				String strBtn = btnTuikaH.getText();

			    if(strBtn != null) {
			    	switch(strBtn){
			        case "ǉ":
					          model.addElement(txtExtension.getText().trim());
					          txtExtension.setText("");
						      btnDell.setEnabled(true);
			            break;
			        case "ҏW":
					      if (!lstExtension.isSelectionEmpty()) {
					          int index = lstExtension.getSelectedIndex();
					          model.set(index,txtExtension.getText().trim());
					          txtExtension.setText("");
						      btnTuikaH.setText("ǉ");
						      btnDell.setEnabled(true);
					      }
			            break;
			        default:
						SearchApp.showMessage("gqIĂB");
			    }
			    }
			}
		   });

		/***********************************************************/
		/*      @^u                                                                                        */
		/***********************************************************/
	   linborderSearch = new LineBorder(Color.lightGray, 1,true);
	   TitledBorder borderSearch =
	     new TitledBorder(linborderK, "@", TitledBorder.LEFT, TitledBorder.TOP);

	   panelSearch.setPreferredSize(new Dimension(350,400));
	   panelSearch.setBorder(borderSearch);

	   //chkSearch = new JCheckBox("K\ȊOł̌");

	    rdoS = new JRadioButton[4];
	    rdoS[0] = new JRadioButton("K\");
	    rdoS[1] = new JRadioButton("(1)");
	    rdoS[2] = new JRadioButton("(2)");

	    ButtonGroup groupS = new ButtonGroup();
	    groupS.add(rdoS[0]);
	    groupS.add(rdoS[1]);
	    groupS.add(rdoS[2]);

	    for (int i = 0 ; i < rdoS.length -1; i++){
		      if (rdoS[i].getText().equals(strSearch)){
		        rdoS[i].setSelected(true);
		      }
		    }

	    String tempStr  = "IBM@ɂ錟u(1)vu(2)v܂B<br>"
								 + "@@@ݒt@Cɂ͕ۑȂ̂ōċNŐK\ɐݒ肳܂B<br>"
								 + "@@@Excel,Word,PDFł͖̂ߐK\̌ɂȂ܂B";

		rdoS[1].setToolTipText("<html>uCharBuffergpv</html>");
		rdoS[2].setToolTipText("<html>" + "uBufferedReadergpv</html>");

	    panelSearch.add(rdoS[0]);
	    panelSearch.add(rdoS[1]);
	    panelSearch.add(rdoS[2]);

	    warmLbl = new JLabel();
	    warmLbl.setText("<html>: " + tempStr + "</html>");

	    panelSearch.add(warmLbl);

	   tp.addTab("@",panelSearch);

		/***********************************************************/
		/*      Oσ^u                                                                                               */
		/***********************************************************/
		linborderG = new LineBorder(Color.lightGray, 1,true);
		   TitledBorder borderG =
		     new TitledBorder(linborderG, "O", TitledBorder.LEFT, TitledBorder.TOP);

		   panelDesin.setPreferredSize(new Dimension(350,400));
		   panelDesin.setBorder(borderG);

		    rdoG = new JRadioButton[4];
		    rdoG[0] = new JRadioButton("()");
		    rdoG[1] = new JRadioButton("()");
		    rdoG[2] = new JRadioButton("()");
		    rdoG[3] = new JRadioButton("(Windows)");

		    ButtonGroup group = new ButtonGroup();
		    group.add(rdoG[0]);
		    group.add(rdoG[1]);
		    group.add(rdoG[2]);
		    group.add(rdoG[3]);

		    String tempGStr  = "Iɍ܂Bݒt@Cɂ͕ۑ܂B</html>";

			rdoG[0].setToolTipText("<html>Iɍ܂Bݒt@Cɂ͕ۑȂ̂<br>"
					+ "ċNŃftHg\ɖ߂܂B</html>");

		    panelDesin.add(rdoG[0]);
		    panelDesin.add(rdoG[1]);
		    panelDesin.add(rdoG[2]);
		    panelDesin.add(rdoG[3]);

		    warmGLbl = new JLabel();
		    warmGLbl.setText("<html>: " + tempGStr + "</html>");

		    panelDesin.add(warmGLbl);

		   tp.addTab("O",panelDesin);


	   /* OK{^ */
	   btnOK.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){

			/* GREPI */
			if( !GrepTaskWorker.cancelbool ) {
				SearchApp.showMessage("<html>sȂ̂ŕύXł܂B<br>LZ{^ă_CAOĂB</html>");
				return;
			}

			/* Oϐݒ */
			setLookAndFeel();
			/* gqtB^ۑ */
			for (int i =0; i < model.getSize(); i++) {
				arExFilter.add(model.getElementAt(i));
			}
			/* Iꂽ@ۑ */
		    for (int i = 0 ; i < rdoS.length -1 ; i++){
			      if (rdoS[i].isSelected()) {
			        strSearch = rdoS[i].getText();
			      }
		    }

			/* init@C֏ */
			try {
				/* ݂̉ʂ̑傫\ʒuݒt@C֕ۑ */
				/* ݒt@Cꍇ͍쐬 */
				setup.createSetupFile();
				/* ݂̉ʂ̑傫\ʒuݒt@C֕ۑ  eTabɓĂJComboBox̒lݒt@C֕ۑ */
				setup.getInfo(searApp, searApp.grepTab, searApp.fileTab);
			}catch (Exception err){
			}finally{
			}

			canceld = false;
			dispose();
		}
	   });

	   /*LZ{^*/
	   btnCancel.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			canceld = true;
			// @߂
		    for (int i = 0 ; i < rdoS.length -1; i++){
			      if (rdoS[i].getText().equals(strSearch)){
			        rdoS[i].setSelected(true);
			      }
			    }
			dispose();
		}
	   });

	   /* ʏI{^ */
	   addWindowListener(new WindowAdapter() {
		 public void windowClosing(WindowEvent e) {
		 	canceld = true;
		 	dispose();
		 }
		 });

	   }

	/**
	 * gq邩`FbN.
	 * @return  `FbNŌ肪Ȃfalse  肪trueԂ
	 */
	public Boolean extentionCheck() {

		//Boolean flg = false;

		// ͂̏ꍇG[\
		if ( txtExtension.getText().trim().equals("") ) {
			SearchApp.showMessage("͂łBgq͂ĂB");
			return true;
		}

		// 擪Ɂu.vĂȂꍇG[\
		if ( !txtExtension.getText().trim().substring(0,1).equals(".") ) {
			SearchApp.showMessage("擪Ɂu.vtĊgq͂ĂB");
			return true;
		}

		// gqꍇG[\
		for ( int i = 0; i < model.getSize(); i++ ) {
			if ( model.getElementAt(i).equalsIgnoreCase(txtExtension.getText()) ) {
				SearchApp.showMessage("gqłɐݒ肳Ă܂B");
				return true;
			}
		}

		return false;
	}

	/**
	 *  IꂽWI{^Oϐݒ.
	 */
	public void setLookAndFeel() {
		/** IꂽWI{^̕ۑ. */
	    String name = "";
	    InputStream istream = null;
	    Boolean bl = false;

	    for (int i = 0 ; i < rdoG.length; i++){
	      if (rdoG[i].isSelected()){
	        name = rdoG[i].getText();
	      }
	    }

	    if(name != null) {
	    	switch(name){
	        case "()":
				/** X^C */
				istream = SearchApp.class.getResourceAsStream("Synth_purple.xml");
	            break;
	        case "()":
				/** X^C */
	        	istream = SearchApp.class.getResourceAsStream("Synth_black.xml");
	            break;
	        case "()":
				/** X^C */
	        	istream = SearchApp.class.getResourceAsStream("Synth_blue.xml");
	            break;
	        case "(Windows)":
	        	istream = null;
	        	bl = false;
	            break;
	        default:
	        	istream = null;
	        	bl = true;
	    	}
	    }

	    if ( bl ) {
	    	/* WI{^IĂȂ牽Ȃ */
	    	return;
	    }
		/** X^C */
		try{
			SynthLookAndFeel synth = new SynthLookAndFeel();
			if (istream != null) {
			   synth.load(istream, SearchApp.class);
			   UIManager.setLookAndFeel(synth);
			} else {
				   UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			}
			SwingUtilities.updateComponentTreeUI(searApp);
			/* ACRݒ */
			if ( SearchApp.iconUrl[8] != null ) {
				setIconImage(Toolkit.getDefaultToolkit().createImage(SearchApp.iconUrl[8]));
			} else {
				setIconImage(null);
			}
		} catch (Exception e1) {
		}
	}

	public void setVisible(boolean b) {
		tp.setSelectedIndex(0);
		super.setVisible(b);
	}

//	public static void main(String args[]) {
//
//		try {
//			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
//		} catch (ClassNotFoundException e1) {
//			// TODO ꂽ catch ubN
//			e1.printStackTrace();
//		} catch (InstantiationException e1) {
//			// TODO ꂽ catch ubN
//			e1.printStackTrace();
//		} catch (IllegalAccessException e1) {
//			// TODO ꂽ catch ubN
//			e1.printStackTrace();
//		} catch (UnsupportedLookAndFeelException e1) {
//			// TODO ꂽ catch ubN
//			e1.printStackTrace();
//		}
//
//		JFrame myf = new JFrame();
//		ConfigDialog cd = new ConfigDialog(myf);
//
//		JButton jb = new JButton("\");
//
//		//myf.getContentPane().add(cd);
//		myf.getContentPane().add(jb);
//		myf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//		myf.setBounds(10, 10, 400, 500);
//		myf.setTitle("^Cg");
//		myf.setVisible(true);
//
//   jb.addActionListener(new ActionListener(){
//		public void actionPerformed(ActionEvent e){
//	    	cd.setSize(480,450);
//			//cd.setFont(myTextP.getFont());
//	    	cd.setLocation(100, 100);
//	    	cd.setVisible(true);
//
//	    	if(cd.canceld) {
//	    	/* LZ */
//	    		return;
//	    	}
//		}
//	});
//
//}

}