/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.Toolkit;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.IOException;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.plaf.basic.BasicComboBoxEditor;



/**
 * JCombBoxgNX@GfB^̃R|[lgBasicComboBoxEditorgp
 * JTextFieldŎgpł.
 *
 * @author Yuu
 * @version 5.00
 */
public class MyJComboBox extends JComboBox {

	/** ENbNp̃|bvAbvj[. */
	private JPopupMenu mouseMenu;
	/** Rs[j[. */
	private JMenuItem copyItem;
	/** \tj[. */
	private JMenuItem  haritukeItem;
	/** 폜. */
	private JMenuItem dellItem;
	/** t镶. */
	private String paste = "";
	/** IĂ镶ۑ. */
	private String selectStr = "";
	/** }Ŏgp镶. */
	private StringBuffer currentStr = new StringBuffer();
	/** IĂ镶̍ŏ̈ʒu. */
	private int selectStart = 0;
	/** IĂ镶̍Ō̈ʒu. */
	private int selectEnd = 0;

	/* JtextFieldփLXg */
	private JTextField jt;

	/** JComboBox R|[lgɎgGfB^R|[lg. */
	BasicComboBoxEditor BcombEditor;


	public MyJComboBox (String strItems[]) {

		super(strItems);

		setEditable(true);

		mouseMenu = new JPopupMenu();
		copyItem = new JMenuItem("Rs[");
		haritukeItem = new JMenuItem("\t");
		dellItem = new JMenuItem("폜");

		mouseMenu.add(copyItem);
		mouseMenu.addSeparator();
		mouseMenu.add(haritukeItem);
		mouseMenu.addSeparator();
		mouseMenu.add(dellItem);

		BcombEditor = (BasicComboBoxEditor) this.getEditor();
		/* GfB^̃R|[lgݒ */
		this.setEditor(new BasicComboBoxEditor());

		final MyJComboBox mcomb = this;

		/*  ENbN@|bvAbv\Cxg                                                                                    */
		/* CxgComboBoxEditorɑ΂čs (Cxg setEditabletruew肵Ă̂) */
		this.getEditor().getEditorComponent().addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {

				/* JComboBox̃GfB^𓾂 */
				BcombEditor = (BasicComboBoxEditor) mcomb.getEditor();
				/* JtextFieldփLXg */
				jt = (JTextField) BcombEditor.getEditorComponent();

				try {

					/* VXeNbv{[h̏𓾂 */
					SearchApp.clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
					/* Nbv{[h當𓾂 */
					paste = (String) SearchApp.clipboard.getData(DataFlavor.stringFlavor);

				} catch (UnsupportedFlavorException e1) {
					// TODO ꂽ catch ubN
					//e1.printStackTrace();
					/* Nbv{[hɒlȂAoȂꍇ null ݒ肵Ă */
					paste = null;
				} catch (IOException e1) {
					// TODO ꂽ catch ubN
					//e1.printStackTrace();
					/* Nbv{[hɒlȂAoȂꍇ null ݒ肵Ă */
					paste = null;
				}

				/* StringBuffer̓e */
				currentStr.delete( 0, currentStr.length() );

				if ( jt == null ) {
					jt.setText("");
				}

				/* ݕ\Ă镶StringBuffer֑ */
				currentStr.append( jt.getText() );

				/* IĂStartʒu */
				selectStart = jt.getSelectionStart();
				/* IĂEndʒu */
				selectEnd = jt.getSelectionEnd();

				/** ENbN */
				if (SwingUtilities.isRightMouseButton(e)) {

					/* IĂeLXg𓾂 */
					selectStr = jt.getSelectedText();

					/* IĂeLXgꍇ */
					if ( selectStr == null ) {
						/* Rs[j[IłȂ悤ɐݒ */
						copyItem.setEnabled(false);
						/* 폜j[IłȂ悤ɐݒ */
						dellItem.setEnabled(false);
					} else {
						copyItem.setEnabled(true);
						dellItem.setEnabled(true);
					}

					/* Nbv{[hɒlꍇ */
					if ( paste ==null ) {
						/* \tj[IłȂ悤ɐݒ */
						haritukeItem.setEnabled(false);
					} else {
						haritukeItem.setEnabled(true);
					}

					/* |bvAbvj[\ */
					mouseMenu.show(e.getComponent(), e.getX(), e.getY());

					/* NbNJComboBoxփtH[JX (J[\\) */
					mcomb.requestFocusInWindow();

				} else {
					/* |bvAbvj[\ */
					mouseMenu.setVisible(false);
				}
			}
		});

		/* Rs[ */
		copyItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				/* Nbv{[hփRs[ */
				SearchApp.clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
				SearchApp.selection = new StringSelection(selectStr);
				SearchApp.clipboard.setContents(SearchApp.selection, null);
			}
		});

		/* \t */
		haritukeItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				/* ݕ\Ă镶(StringBuffer)ɑ΂āALbg̈ʒu֕} *
				 * IԂ̏ꍇ͑Iꂽw肵pastɒu܂ */
				currentStr.replace(selectStart, selectEnd, paste);
				/* JComboBoxŌݕ\Ăʒu֕ύXݒ肷 */
				mcomb.setSelectedItem(currentStr.toString());
				/* Lbg̈ʒuݒ */
				jt.setCaretPosition(selectStart + paste.length());
				/* NbNJComboBoxփtH[JX (J[\\) */
				mcomb.requestFocusInWindow();
			}
		});

		/* 폜 */
		dellItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				//System.out.println("\e: " + currentStr + " Strat : " + selectStart + " End : " + selectEnd + " Lbg : " + caretPosition);
				/* ݕ\Ă镶(StringBuffer)ɑ΂āAIĂ镶폜 */
				currentStr.delete(selectStart, selectEnd);
				/* JComboBoxŌݕ\Ăʒu֕ύXݒ肷 */
				mcomb.setSelectedItem(currentStr.toString());
				/* Lbg̈ʒuݒ */
				jt.setCaretPosition(selectStart);
			}
		});
	}

	/**
	 * ^u(GREP^u,File^u)ŕ\ĂJCombBox֕ǉۑ.
	 */
	public void setComboBoxStr() {
		/** IĂ镶𓾂 */
		String charaCombStr =  this.getSelectedItem().toString();

		/* ȂۑȂ */
		if ( charaCombStr.equals("") ) {
			return;
		}

		/* ΕۑȂ */
		for ( int i = 0; i < this.getItemCount(); i++ ) {
			if ( charaCombStr.equals( this.getItemAt(i) ) ) {
				return;
			}
		}

		/* JComboBoxŒl͂ĂꍇœlȂꍇɒlǉ */
		//if ( !charaCombStr.equals("") && !charaCombStr.equals(this.getItemAt(0)) ) {
			this.insertItemAt(charaCombStr,0);
			this.setSelectedIndex(0);
		//}
	}

	//	public static void main(String[] args) {
	//
	//		JFrame myf = new JFrame();
	//		MyJComboBox mycomb = new MyJComboBox(new String[]{""});
	//		//mycomb.setEditable(true);
	//
	//		myf.getContentPane().add(mycomb);
	//		myf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	//		myf.setBounds(10, 10, 400, 100);
	//		myf.setTitle("^Cg");
	//		myf.setVisible(true);
	//
	//	}
}
