/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.Dimension;
import java.awt.Toolkit;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JComboBox;


/**
 * @author Yuu
 * @version 14.01
 */
public class Setup {

	/** ۑ鏉ݒ. */
	private final String strWindowInfo[] = { "Size_W=" , "Size_H=" ,
			"Posi_Y=" , "Posi_X=","JSplit_W="};

	/**  fXNgbṽTCY𓾂.*/
	final Dimension pcscreenSize = Toolkit.getDefaultToolkit().getScreenSize();

	/**  fXNgbvwideTCY.*/
	final int w = pcscreenSize.width;
	/**  fXNgbvheightTCY.*/
	final int h = pcscreenSize.height;

	/** GREP. */
	private final String strfileCombB = "grepFileCombB=";

	/** GREPpX. */
	private final String pathCombB = "pathCombB=";

	/** GREP gqtB^[. */
	private final String filterCombB = "filterCombB=";

	/** FileSearchTabt@CtB^[. */
	private final String fileCombB = "fileCombB=";

	/** FileSearchTabt@CtB^[. */
	private final String pathCombFileB = "pathCombFileB=";

	/** gqtB^. */
	private final String extension = "ex=";

	/** gqtB^ۑp. */
	//ArrayList<String> arlEx;

	/** gqList\f[^. */
	public DefaultListModel<String> ml;

	/** ʂ̐ݒAe͒l̒lێ. */
	private List<String> infoWindowsValue = new ArrayList<String>();

	/** ݒt@CۑfBNg. */
	private final String FOLDEREUSR = "usr";
	/** ݒt@C. */
	private final String SETUPFILE = "setup.ini";

	/** ݒt@C̈ʒu(usr/setup.ini). */
	private final String FOLDER_SETUPFILE = FOLDEREUSR +  SearchApp.SEPARATOR + SETUPFILE;
	//private final String FOLDER_SETUPFILE = FOLDEREUSR +  "/" + SETUPFILE;

	/** ݒt@CۑfBNgURL. */
	private URL FOLDER_URL = null;

	/** ݒt@CURL. */
	private URL SETUPINI_URL = null;

	Setup(){
		FOLDER_URL = this.getClass().getResource(FOLDEREUSR);

		SETUPINI_URL = this.getClass().getResource(SETUPFILE);
		//System.out.println(FOLDER_SETUPFILE);
	}


	/**
	 * ݒt@Cꍇ쐬.
	 * @throws Exception
	 * @throws IOException   G[
	 */
	public void createSetupFile() throws Exception,IOException {
		//boolean create = false;

		if (FOLDER_URL == null) {
			/*	usrtH_̂ō쐬 */
			//System.out.println("usr쐬");
			/* tH_ꍇ */
			new File(FOLDEREUSR).mkdir();
			/* setup.init@C쐬 */
			//System.out.println("usrsetup.ini쐬");
			new File(FOLDER_SETUPFILE).createNewFile();

		} else if (FOLDER_URL != null || SETUPINI_URL == null) {
			/* usrtH_͂邪setup.init@Cꍇ */
			//System.out.println("setup.ini쐬");
			/* setup.init@C쐬 */
			new File(FOLDER_SETUPFILE).createNewFile();

		} else {
			/* usrtH_setup.init@CL鎞 */
			//System.out.println("zuĂ");
		}

	}

	/**
	 * ݒt@C̓eǂݍ.
	 * @throws IOException   G[
	 */
	public void readSetupIni() throws Exception , IOException  {
		FileReader freader = new FileReader(FOLDER_SETUPFILE);
		BufferedReader breader = new BufferedReader(freader);
		String strValue;
		//int i = 0;
		while ((strValue = breader.readLine()) != null) {
			infoWindowsValue.add( new String(strValue) );
			//System.out.println((String)infoWindowsValue.get(i));
			//++i;
		}

		freader.close();
	}

	/**
	 * ݒt@Cɏ.
	 * @throws Exception
	 * @throws IOException
	 */
	public void writeSetupIni() throws Exception,IOException {
		FileWriter fwriter = new FileWriter(FOLDER_SETUPFILE);
		BufferedWriter bwriter = new BufferedWriter(fwriter);

		for (int i = 0; i < infoWindowsValue.size(); i++) {
			bwriter.write(infoWindowsValue.get(i));
			bwriter.newLine();
		}

		bwriter.flush();
		fwriter.close();
	}

	/**
	 * R|[lgel𓾂ArrayListɕۑ.
	 * @param frame     SearchApp
	 * @param gTab      Grep^u
	 * @param fileSTab  t@C^u
	 *
	 * @throws Exception
	 * @throws IOException
	 */
	public void getInfo(SearchApp frame,GrepTab gTab,FileSearchTab fileSTab) throws Exception , IOException {
		/** ꎞIɒlϐ. */
		String strtemp = "";

		/** JComboBox̃IuWFNgꎞIɕۑ */
		JComboBox tempJcomb;

		//arlEx = new ArrayList<String>();

		infoWindowsValue.clear();

		/* 𓾂 */
		strtemp = String.valueOf(frame.getWidth());
		infoWindowsValue.add( strWindowInfo[0] + strtemp );
		/* 𓾂 */
		strtemp = String.valueOf(frame.getHeight());
		infoWindowsValue.add( strWindowInfo[1] + strtemp );
		/* Y𓾂 */
		strtemp = String.valueOf(frame.getY());
		infoWindowsValue.add( strWindowInfo[2] + strtemp );
		/* X𓾂 */
		strtemp = String.valueOf(frame.getX());
		infoWindowsValue.add( strWindowInfo[3] + strtemp );
		/* JTree\̕𓾂 */
		strtemp = String.valueOf( frame.getJSplitpane().getDividerLocation() );
		infoWindowsValue.add( strWindowInfo[4] + strtemp );

		/* GREP𓾂ċL^ */
		tempJcomb = gTab.grepFileCombB;
		for (int i = 0; i < tempJcomb.getItemCount(); i++) {
			strtemp = tempJcomb.getItemAt(i).toString();

			if ( !strtemp.equals("") ) {
				infoWindowsValue.add( strfileCombB + strtemp );
			}
			//System.out.println(" R{{bNX: " + strfileCombB + strtemp);
			//System.out.println(" R{: " + tempJcomb.getItemCount());
			if ( i > 9 ) {
				/* l10܂ŋL^*/
				break;
			}
		}

		/* GREP pX̕𓾂ċL^ */
		tempJcomb = gTab.pathCombB;
		for (int i =0; i < tempJcomb.getItemCount(); i++) {
			strtemp = tempJcomb.getItemAt(i).toString();

			if ( !strtemp.equals("") ) {
				infoWindowsValue.add( pathCombB + strtemp );
			}
			//System.out.println(" R{{bNX: " + pathCombB + strtemp);
			//System.out.println(" R{: " + tempJcomb.getItemCount());
			if ( i > 9 ) {
				/* l10܂ŋL^ */
				break;
			}
		}

		/* GREP t@CtB^[̕𓾂ċL^ */
		tempJcomb = gTab.filterCombB;
		for (int i =0; i < tempJcomb.getItemCount(); i++) {
			strtemp =  tempJcomb.getItemAt(i).toString();

			if ( !strtemp.equals("") ) {
				infoWindowsValue.add( filterCombB + strtemp );
			}
			//System.out.println(" R{{bNX: " + tempJcomb.getItemCount());
			if ( i > 9 ) {
				/* l10܂ŋL^ */
				break;
			}
		}

		/* t@CtH_^u t@C͂̕𓾂ċL^ */
		tempJcomb = fileSTab.fileCombB;
		for (int i =0; i < tempJcomb.getItemCount(); i++) {
			strtemp = tempJcomb.getItemAt(i).toString();

			if ( !strtemp.equals("") ) {
				infoWindowsValue.add( fileCombB + strtemp );
			}
			//System.out.println(" R{{bNX: " + tempJcomb.getItemCount());
			if ( i > 9 ) {
				/* l10܂ŋL^ */
				break;
			}
		}

		/* t@CtH_^u pX͂̕𓾂ċL^ */
		tempJcomb = fileSTab.pathCombB;
		for (int i =0; i < tempJcomb.getItemCount(); i++) {
			strtemp = tempJcomb.getItemAt(i).toString();
			if ( !strtemp.equals("") ) {
				infoWindowsValue.add( pathCombFileB + strtemp );
			}
			//System.out.println(" R{{bNX: " + tempJcomb.getItemCount());
			if ( i > 9 ) {
				/* l10܂ŋL^ */
				break;
			}
		}

		/* gqtB^̕𓾂ċL^ */
		ml = frame.confDialog.model;
		for (int i =0; i < ml.getSize(); i++) {
			strtemp = ml.getElementAt(i);
			if ( !strtemp.equals("") ) {
				infoWindowsValue.add( extension + strtemp );
			}
		}

		/* ݒt@Cɏ */
		writeSetupIni();
	}

	/**
	 * ŗ^ꂽR|[lgɕAAwCxlݒ肷.
	 * @param frame     SearchApp
	 * @param gTab       Grep^u
	 * @param fileSTab  t@C^u
	 *
	 * @throws Exception
	 * @throws IOException
	 */
	public void setSetupInfo(SearchApp frame,GrepTab gTab,FileSearchTab fileSTab) throws Exception , IOException{
		/* ݒt@C̓eǂݍ */
		readSetupIni();

		/* ʂ̑傫ƈʒuۑ */
		String strtemp[] = new String[infoWindowsValue.size()];

		for (int i = 0; i < infoWindowsValue.size(); i++) {
			String str = infoWindowsValue.get(i);
			if ( i < strWindowInfo.length ) {
				/* ʂ̑傫TCY@ʒȕ "="ȉ̒lo */
				strtemp[i] = str.substring( str.indexOf('=') + 1 );
			} else {
				/* eJConboBoxɐݒ肷lo */
				strtemp[i] = str;
			}
			/* = ȉ̒lꍇG[Ԃ */
			if ( strtemp[i] == null || strtemp[i].length() == 0 ) {
				throw new Exception();
			}
		}

		/* ʂ̑傫Aʒuݒ肷鏈 */
		/* ƍݒ */
		//frame.setSize(Integer.parseInt(strtemp[0]) ,
				//Integer.parseInt(strtemp[1]));
		/* ƍݒ(fXNgbṽTCYvZĔzuAēxNĂ傫) */
		frame.setSize(w/2,h/2);

		/* XYݒ */
		//frame.setLocation(Integer.parseInt(strtemp[3]) ,
				//Integer.parseInt(strtemp[2]));
		/* XYݒ(fXNgbṽTCYvZĔzuAēxNĂʒu)  */
		frame.setLocation(w/8,h/8);

		/* ʕ̕ݒ */
		frame.getJSplitpane().setDividerLocation(Integer.parseInt(strtemp[4]));

		/* JComboBoxɒlݒ肷鏈 */
		/* JComboBoxɏt@C̒lݒ肷 */
		for (int i = 5; i < strtemp.length; i++) {
			//System.out.println( strtemp[i] );
			if ( strtemp[i].startsWith(strfileCombB) ) {
				/* GrepTab GREP */
				gTab.grepFileCombB.addItem( strtemp[i].substring( strtemp[i].indexOf('=') + 1 ));
			} else if ( strtemp[i].startsWith(pathCombB) ) {
				/* GrepTab pX */
				gTab.pathCombB.addItem( strtemp[i].substring( strtemp[i].indexOf('=') + 1 ));
			} else if ( strtemp[i].startsWith(filterCombB)) {
				/* GrepTab gqtB^[  */
				gTab.filterCombB.addItem( strtemp[i].substring( strtemp[i].indexOf('=') + 1 ));
			} else if ( strtemp[i].startsWith(fileCombB) ) {
				/* FileSearchTab t@C@tH_ */
				fileSTab.fileCombB.addItem( strtemp[i].substring( strtemp[i].indexOf('=') + 1 ));
			} else if ( strtemp[i].startsWith(pathCombFileB) ) {
				/* FileSearchTab pX */
				fileSTab.pathCombB.addItem( strtemp[i].substring( strtemp[i].indexOf('=') + 1 ));
			} else if ( strtemp[i].startsWith(extension) ) {
				/* gqtB^ vpeB_CAOListɕۑ */
				frame.confDialog.model.addElement( strtemp[i].substring( strtemp[i].indexOf('=') + 1 ) );
				/* gqtB^ tB^[NXɕۑ */
				FileExtensionInitFilter.extensionArry.add( strtemp[i].substring( strtemp[i].indexOf('=') + 1 ) );
			}
		}
	}

	/**
	 * ftHg̒lݒ.
	 * @param frame     SearchApp
	 * @param gTab      Grep^u
	 * @param fileSTab  t@C^u
	 */
	public void setDefaultInfo(SearchApp frame,GrepTab gTab,FileSearchTab fileSTab) {

		/* ƍݒ */
		//frame.setSize(683,553);
		frame.setSize(w/2,h/2);
		/* XYݒ */
		//frame.setLocation(40,30);
		frame.setLocation(w/8,h/8);

		/* ftHgŃtB^[(Ȃgq̃t@C)gq */
		FileExtensionInitFilter.extensionArry.add(".BMP");
		FileExtensionInitFilter.extensionArry.add(".JPEG");
		FileExtensionInitFilter.extensionArry.add(".JPG");
		FileExtensionInitFilter.extensionArry.add(".PNG");
		FileExtensionInitFilter.extensionArry.add(".GIF");
		FileExtensionInitFilter.extensionArry.add(".TIFF");
		FileExtensionInitFilter.extensionArry.add(".TIF");
		FileExtensionInitFilter.extensionArry.add(".dll");
		FileExtensionInitFilter.extensionArry.add(".exe");
		FileExtensionInitFilter.extensionArry.add(".dmp");
		FileExtensionInitFilter.extensionArry.add(".db");
		FileExtensionInitFilter.extensionArry.add("Thumbs.db");
		FileExtensionInitFilter.extensionArry.add(".ico");
		FileExtensionInitFilter.extensionArry.add(".ACCDU");
		FileExtensionInitFilter.extensionArry.add(".tga");
	}

}
