/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import org.apache.pdfbox.pdfparser.PDFParser;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.util.PDFTextStripper;


/**
 * PDFt@CǂݍރNX
 * 
 * @author Yuu
 * @since 2012-12
 */
public class PDFSearch {

	/** PDFhLg.  */
	private  PDDocument pdfDocu = null;

	/**  PDFParser. */
	private PDFParser pdfParser;

	/** PDFTextStripper. */
	private PDFTextStripper pdfTextStrip;

	private FileInputStream pdfFileStream = null;

	/** PDFt@C̕ۑ. */
	private String pdfStr;

	/** GREPŃqbglۑ. */
	ArrayList<String[]> arrkekka;


	/**
	 * ocet@C當String^肾D
	 * @param pdfFile@@@@ t@CD
	 * @return@@@@@@@@ocet@CString^擾.
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	public String getPDFString(File pdfFile) throws FileNotFoundException, IOException {

		pdfFileStream = new FileInputStream(pdfFile);

		pdfParser = new PDFParser(pdfFileStream);

		pdfParser.parse();

		pdfDocu = pdfParser.getPDDocument();

		pdfTextStrip = new PDFTextStripper();

		/* PDFt@C̕擾 */
		pdfStr = pdfTextStrip.getText(pdfDocu);

		return pdfStr;

	}

	/**
	 * PDF當擾ĂfqdoČʂԂD
	 * @param pdfFile@@@ ocet@C
	 * @param grepSearch@fqdoT[`NX
	 * @return                     fqdoStringz
	 * @throws Exception
	 */
	public ArrayList<String[]> getPDFFileGrep(File pdfFile,GrepSearch grepSearch) throws Exception {

		arrkekka = new ArrayList<String[]>();

		/* PDFt@CString^ */
		pdfStr = getPDFString( pdfFile ); 

		/* ocet@C瓾String^grepČʂArrayList̔zŕԂ. */
		arrkekka = grepSearch.getPDFGrep(pdfFile, pdfStr);

		return arrkekka;

	}

	//	public static void main(String[] args) {
	//		
	//		PDFSearch pdfs = new PDFSearch();
	//		
	//		ArrayList<String[]> arrkekka = new ArrayList<String[]>();	
	//		
	//		/** GrepNX. */
	//		GrepSearch grepSearch = new GrepSearch();
	//		
	//		String pdfStr;
	//		
	//		try {
	//			
	//			grepSearch.compile("A",GrepTab.mojiCheck.isSelected());			
	//			pdfStr = pdfs.getPDFString(new File("C:\\word\\121030report.pdf"));
	//			
	//
	//				arrkekka = grepSearch.getPDFGrep(new File("C:\\word\\121030report.pdf"),pdfStr);
	//
	//			for (int i = 0; i < arrkekka.size(); i++) {
	//				String[] str = arrkekka.get(i);
	//				System.out.println(str[3]);
	//			}			
	//			
	//			//System.out.println(pdfStr);
	//			
	//		} catch (FileNotFoundException e) {
	//			// TODO ꂽ catch ubN
	//			e.printStackTrace();
	//		} catch (IOException e) {
	//			// TODO ꂽ catch ubN
	//			e.printStackTrace();
	//		} catch (Exception e) {
	//			
	//		}

	//	}

}
