/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.regex.PatternSyntaxException;

/**
 * tH_At@CNX.
 * @author Yuu
 * @virsion 3.0
 * @since 2011
 */
public class FileSearch {

	// 
	private Pattern pattern;

	/** ʕۑf[^NX. */
	private DataSearch dataSearch = new DataSearch();

	/** t@C̍XV\`. */
	public SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy'/'MM'/'dd  H':'mm");

	/**
	 *  𐳋K\.
	 * @param pat  
	 * @param capitalLetter 啶
	 */
	public void compile(String pat,boolean capitalLetter) throws Exception , PatternSyntaxException {
		//pat = pat;
		if (capitalLetter == true) {
			/* 啶ʂ */
			pattern = Pattern.compile(pat);
		} else {
			/* 啶ʂȂ */
			pattern = Pattern.compile(pat,Pattern.CASE_INSENSITIVE);
		}
	}

	/**
	 * tH_At@C@œt@C̖OĈvt@CtH_̏Ԃ.
	 * @param f   Ώۃt@C
	 * @return     Ń}b`t@C̏ԂB1̃t@C@1s
	 */
	public ArrayList<String[]> search(File f) throws Exception {

		/** ʂPsÂۑ. */
		ArrayList<String[]> arrKekkaRow = new ArrayList<String[]>();
		//String data[] = new String[4];
		/** t@C. */
		String fileStr = f.getName();
		/** gq. */
		String endStr = "";
		/** TCY. */
		String sizeStr = "";
		/** t@C̍XV. */
		String lasthiniti = sdf1.format( new Date( f.lastModified() ) );

		/* e[uɕ\镶 */
		Matcher mctxt = pattern.matcher(fileStr);

		/*  */
		if(mctxt.find()){

			/* gq̏ */
			int poi = fileStr.lastIndexOf(".");
			if (poi != -1) {
				endStr = fileStr.substring(poi);
			}
			/* t@CȂTCY͓̏Ȃ */
			if ( !f.isDirectory() ) {
				sizeStr = String.valueOf(f.length());
			}

			/* }b`镶܂ޏꍇ	 */
			/* ̃t@CԂ(t@C̃f[^zs) */
			arrKekkaRow.add(dataSearch.setFileSearchNaiyouStr(fileStr,f,sizeStr,endStr,lasthiniti,""));
		}

		return arrKekkaRow;
	}

	/**
	 * ʕ\e[u̐Fp.
	 * @param grepStr   (镶)
	 * @param textF     \Ă镶(Ώ)
	 * @param mojiCheck 啶
	 *
	 * @return
	 */
	public ArrayList<int[]> hightLiteGrep(String grepStr,String textF,boolean mojiCheck) throws Exception {

		/** ʈʒuۑ. */
		ArrayList<int[]> arrKekka = new ArrayList<int[]>();

		int position[];

		/* 镶𐳋K\ */
		compile(grepStr,mojiCheck);

		/* e[uɕ\镶 */
		Matcher mctxt = pattern.matcher(textF);

		while(mctxt.find()){  // }b`镶܂ތJԂ
			/* Ńqbg̈ʒuz֕ۑ */
			position = new int[2];
			position[0] = mctxt.start();
			position[1] = mctxt.end();

			arrKekka.add(position);
		}

		return arrKekka;
	}

}
