/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

/**
 *  ^uclass
 * @author Yuu
 * @version 1.0
 * @since 2010-09
 */
class MyJTabbedPaneS extends JTabbedPane {
	private static final Icon icon = new CloseTabIcon();

	public MyJTabbedPaneS() {
		super();
	}

	/**
	 * @Override
	 * 
	 * @param title t@C̐΃pXĂ : content Tabɏ悹eLXgR|[lg.
	 * 
	 * */
	public void addTab(String title, final Component content) {
		JPanel tab = new JPanel(new BorderLayout());
		tab.setOpaque(false);

		/* Tab̃^Cg t@C */
		JLabel label = new JLabel(title);
		label.setBorder(BorderFactory.createEmptyBorder(0,0,0,4));
		JButton button = new JButton(icon);
		button.setPreferredSize(new Dimension(icon.getIconWidth(),
				icon.getIconHeight()));
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				   removeTabAt(indexOfComponent(content));
			}
		});

		tab.add(label,  BorderLayout.WEST);
		tab.add(button, BorderLayout.EAST);
		tab.setBorder(BorderFactory.createEmptyBorder(2,1,1,1));
		super.addTab(title, content);
		setTabComponentAt(getTabCount()-1, tab);
	}

	/**
	 * @param index Tab̃CfbNX title ^ũ^Cg
	 * 
	 * */
	public void setTabListTitle(int index,String title) {

		JPanel panel = (JPanel)this.getTabComponentAt(index);

		JLabel titlelabel = (JLabel)panel.getComponent(0);
		titlelabel.setText(title);

	}

	private static class CloseTabIcon implements Icon {
		private int width;
		private int height;
		public CloseTabIcon() {
			width  = 16;
			height = 16;
		}
		//@Override
		public void paintIcon(Component c, Graphics g, int x, int y) {
			g.translate(x, y);
			g.setColor(Color.BLACK);
			g.drawLine(4,  4, 11, 11);
			g.drawLine(4,  5, 10, 11);
			g.drawLine(5,  4, 11, 10);
			g.drawLine(11, 4,  4, 11);
			g.drawLine(11, 5,  5, 11);
			g.drawLine(10, 4,  4, 10);
			g.translate(-x, -y);
		}
		public int getIconWidth() {
			return width;
		}
		public int getIconHeight() {
			return height;
		}

	}
}


