/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.Color;
import java.awt.Component;
import java.awt.Desktop;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JTable;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.event.MouseInputAdapter;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;


/**
 * Grepʕ\e[u
 * @upX  t@C  sԍ  e  Fv 5  F͕\Ȃ
 * e ̗̓L[[h\
 * @author Yuu
 */
public class TableResult  extends JTable implements ITableResult{

	/** e[ũf[^. */
	private DefaultTableModel dfTable;

	/** JTable̗. */
	final static String[] strColum ={"t@C"," pX","sԍ","e","F"};
	/** JTable̒l. */
	static String[][] strTable = new String[0][];

	/** e[u̗̕\ݒ */
	private TableColumn column;

	/** e[ũZ̕`. */
	private TextFieldCellRenderer txtfCellRend;

	/** xgpǂ. */
	private boolean chkflg = false;

	/** vOXo[ɕ\錋. */
	public String progresBarStr = new String();

	/** ENbNp̃|bvAbvj[. */
	private final JPopupMenu mouseMenu;
	/** pXRs[j[. */
	private JMenuItem pathItem;
	/** eRs[j[. */
	private JMenuItem naiyouItem;
	/** Jj[. */
	private JMenuItem openItem;
	/** t@C̏ꏊJj[. */
	private JMenuItem openFoldItem;

	/** Nbv{[h. */
	//Clipboard clipboard;
	//StringSelection selection;

	/** t@CJŎgp. */
	Desktop desktop = Desktop.getDesktop();

	/** GrepTabNX. */
	private GrepTab gTab;

	TableResult() {

		/*******}EXENbÑ|bvAbvj[**********************/
		mouseMenu = new JPopupMenu();
		pathItem = new JMenuItem("pXRs[");
		naiyouItem = new JMenuItem("eRs[");
		openItem = new JMenuItem("t@CJ");
		openFoldItem = new JMenuItem("t@C̏ꏊJ");

		mouseMenu.add(pathItem);
		mouseMenu.addSeparator();
		mouseMenu.add(naiyouItem);
		mouseMenu.addSeparator();
		mouseMenu.add(openItem);
		mouseMenu.addSeparator();
		mouseMenu.add(openFoldItem);
		/*******}EXENbÑ|bvAbvj[**********************/

		/* e[ũf[^Zbg */
		dfTable = new DefaultTableModel ();
		setModel(dfTable);
		/* e[u̗ݒ */
		setDfTableData(strColum, strTable);

		txtfCellRend = new TextFieldCellRenderer();
		/* e[ũf[^ւ̎Q(F݂ɕ\ȂǂŎgp) */
		txtfCellRend.setdfTable(dfTable);
		/* e[ũZ̕`Zbg */
		setDefaultRenderer(Object.class, txtfCellRend);

		/* Z̍ݒ */
		setRowHeight(22);

		/** |bvAbvj[\Cxg. */
		final TableResult tb = this;
		this.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {

				/** ENbN */
				if (SwingUtilities.isRightMouseButton(e)) {
					int col = tb.columnAtPoint(new Point(e.getX(), e.getY()));
					int row = tb.rowAtPoint(new Point(e.getX(), e.getY()));
					tb.setRowSelectionInterval(row, row);

					/* |bvAbvj[\ */
					mouseMenu.show( tb, e.getX(),e.getY() );
					pathItem.setVisible(true);
				}else{
					/* |bvAbvj[\ */
					mouseMenu.setVisible(false);
				}
			}
		});

		/**  |bvAbvj[@pXRs[.       */
		pathItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int colum = tb.getSelectedColumn();
				int row = tb.getSelectedRow();
				String str = (String) getDfTable().getValueAt(row, 1);

				/* Nbv{[hփpXRs[ */
				SearchApp.clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
				SearchApp.selection = new StringSelection(str);
				SearchApp.clipboard.setContents(SearchApp.selection, null);
			}
		});

		/**  |bvAbvj[@eRs[.       */
		naiyouItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int row = tb.getSelectedRow();
				String str = (String) getDfTable().getValueAt(row, 3);

				/* Nbv{[hփpXRs[ */
				SearchApp.clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
				SearchApp.selection = new StringSelection(str);
				SearchApp.clipboard.setContents(SearchApp.selection, null);

			}
		});

		/** |bvAbvj[@t@CJ. */
		openItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int row = tb.getSelectedRow();
				/* t@C̃pX𓾂 */
				String str = (String) getDfTable().getValueAt(row, 1);
				File file = new File(str);

				try {
					/* OSɊ֘AtꂽAvP[VŊJ*/
					desktop.open(file);
				} catch (IOException e1) {
					// TODO ꂽ catch ubN
					e1.printStackTrace();
					SearchApp.showMessage("֘AtꂽAvP[V݂ȂA܂");
				} catch (Exception e2) {
					// TODO ꂽ catch ubN
					e2.printStackTrace();
					SearchApp.showMessage("֘AtꂽAvP[V݂ȂA܂"
							+ SearchApp.crlf + "pXmFĂB");
				}
			}
		});

		/** |bvAbvj[@t@C̏ꏊJ. */
		openFoldItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int row = tb.getSelectedRow();
				/* \Ăe[ut@C̃pX𓾂 */
				String str = (String) getDfTable().getValueAt(row, 1);
				File file = new File(str);

				try {
					/* tH_[OSł̃t@C}l[W[ŊJ*/
					desktop.open(file.getParentFile());
				} catch (IOException e1) {
					// TODO ꂽ catch ubN
					e1.printStackTrace();
					SearchApp.showMessage("tH_J܂BpXmFĂB");
				} catch (Exception e2) {
					// TODO ꂽ catch ubN
					e2.printStackTrace();
					SearchApp.showMessage("tH_J܂BpXmFĂB");
				}
			}
		});

		/** }EXړCxg. */
		 this.addMouseMotionListener(new MouseInputAdapter() {
			 public void mouseMoved(MouseEvent e) {
				 /* [XV */
				SearchApp.taskProBarGc.setString(SearchApp.getMemInfo());
				SearchApp.taskProBarGc.setValue((int)SearchApp.meminfoGC);
			   }
		 });

		/* e[u\f[^́uFv̗TableColumn𓾂 */
		TableColumnModel columnModel = (DefaultTableColumnModel)this.getColumnModel();
		TableColumn column = columnModel.getColumn(4);
		/* uFv̗\ɂ */
		this.removeColumn(column);
	}


	public String getProgresBarStr() {

		return progresBarStr;
	}

	public void setProgressBarStr(String pstr) {
		progresBarStr = pstr;
	}


	/**
	 * ʃe[uփ[U[͂GREPۑĂ.
	 *
	 * @param grepStr GREP
	 */
	public void setSearchStr(String searchStrm) {
		txtfCellRend.setGrepStr(searchStrm);
	}

	/**
	 * GREPԂ.
	 * @return
	 */
	public String getSearchStr() {
		return txtfCellRend.getGrepStr();
	}

	/**
	 * GREP啶lۑ.
	 * @return
	 */
	public void setMojiBool(boolean bool){
		txtfCellRend.setGrepMojiBool(bool);
	}

	/**
	 * ̃e[uxłgꂽmF.
	 * @return gpĂꍇ true  gṕ@false
	 */
	public boolean getChkFlg(){
		return chkflg;
	}


	/**
	 * ̃e[u̎gptOtrueɕύX.
	 * @param flg gpꂽ@true
	 */
	public void setChkFlg(boolean flg){
		chkflg = flg;
	}

	/**
	 * e[ũf[^ get\bh.
	 * @return   e[ũf[^
	 */
	public DefaultTableModel getDfTable() {
		return dfTable;
	}

	/**
	 * e[u̒l̃f[^(ArrayList)ɂ.
	 * @param arrData   e[u̒ľƂȂRNV
	 */
	public void setDfTableData(ArrayList arrData) {

		/* ArrayList̕ԂlPԖڂJString^̔zŎ */
		String[] column = (String[])arrData.get(0);
		/* ArrayList̕Ԃl2ԖڂArrayList^(e[ũf[^) */
		ArrayList tempArr = (ArrayList)arrData.get(1);
		/* ArrayList^̃f[^Object^̂Qz */
		Object[][] ob = (Object[][])tempArr.toArray(new Object[tempArr.size()][]);

		//dfTable = new DefaultTableModel(ob,column);
		dfTable.setDataVector(ob, column);

		setAutoResizeMode( JTable.AUTO_RESIZE_OFF );
		/* ̕ݒ */
		setRowWidth();

	}

	/**
	 * e[u̒lArraylist e[ũ̗^CgzŎ󂯎쐬.
	 * @param arrData   e[u̒l
	 * @param strColum  e[u̗l
	 */
	public void setDfTableDate(ArrayList arrData,String[] strColum) {

		/* ArrayList^̃f[^Object^̂Qz */
		Object[][] ob = (Object[][])arrData.toArray(new Object[arrData.size()][]);

		//dfTable = new DefaultTableModel(ob,column);
		dfTable.setDataVector(ob, strColum);

		setAutoResizeMode( JTable.AUTO_RESIZE_OFF );
		/* ̕ݒ */
		setRowWidth();
	}

	/**
	 * e[u̒lzŎ󂯎쐬.
	 * @param column   e[ũJ.
	 * @param ob          e[u̒l.
	 *
	 * */
	public void setDfTableData(String[] column,Object[][] ob) {
		/* JString^zŐݒAJTable̒l񎟌zŐݒ */
		dfTable.setDataVector(ob, column);

		setAutoResizeMode( JTable.AUTO_RESIZE_OFF );
		/* ̕ݒ */
		setRowWidth();
	}

	/**
	 * zŒl󂯎e[uɍsǉ.
	 * @param strRow
	 */
	public void addTableRow(String strRow[]) {
		//int row = dfTable.getRowCount();
		dfTable.addRow(strRow);
		//TextFieldHighlighter tfhr = (TextFieldHighlighter)this.getDefaultEditor(getColumnClass(3));
		//System.out.println(tfhr);
		//tfhr.setHighlight(GrepTab.grepFileCombB.getSelectedItem().toString());
	}


	/**
	 * e[u̒lׂč폜.
	 */
	public void resetDfTableData() {
		Object[][] ob = new Object[0][];
		String[] str = new String[0];
		this.dfTable.setDataVector(ob,str);

		setAutoResizeMode( JTable.AUTO_RESIZE_OFF );
		/* ̕ݒ */
		setRowWidth();
	}


	/**
	 * e[u̍s폜.
	 */
	public void resetRow() {

		Object[][] ob = new Object[0][];
		dfTable.setDataVector(ob,strColum);

		setAutoResizeMode( JTable.AUTO_RESIZE_OFF );
		/* ̕ݒ */
		setRowWidth();
	}


	//	/* ( Javadoc)
	//	* eXg
	//	* @see javax.swing.JTable#getCellEditor(int, int)
	//	*/
	//	@Override
	//	public TableCellEditor getCellEditor(int row, int column) {
	//	Object value = super.getValueAt(row, column);

	//	if(value != null) {
	//	if(value instanceof TextFieldHighlighter) {
	//	return new DefaultCellEditor((TextFieldHighlighter)value);

	//	}

	//	return getDefaultEditor(value.getClass());

	//	}

	//	return super.getCellEditor(row, column);

	//	}

	/**
	 * e[u̗̕ݒ
	 */
	public void setRowWidth() {

		for (int i = 0; i < strColum.length; i++) {
			column = getTableHeader().getColumnModel().getColumn(i);
			switch (i) {
			case 0:
				column.setPreferredWidth(150);
				//column.setMaxWidth(100);
				//column.setMinWidth(100);
				//getColumnModel().getColumn(i).sizeWidthToFit();
				break;
			case 1:
				//column.setMaxWidth(80);
				//column.setMinWidth(80);
				//getColumnModel().getColumn(i).sizeWidthToFit();
				column.setPreferredWidth(200);
				break;
			case 2:
				//column.setMaxWidth(50);
				//column.setMinWidth(50);
				//getColumnModel().getColumn(i).sizeWidthToFit();
				column.setPreferredWidth(50);
				break;
			case 3:
				//column.setMaxWidth(250);
				//column.setMinWidth(250);
				//getColumnModel().getColumn(i).sizeWidthToFit();
				//column.setCellEditor(new TextFieldCellRenderer(new TextFieldHighlighter()));
				column.setPreferredWidth(300);
				break;
			case 4:
				column.setPreferredWidth(10);
				break;
			}

		}
	}


	/* ( Javadoc)
	 * @see ITableResult#setGrepTab(SearchApp)
	 *
	 * GrepTabNX̃IuWFNgϐgTab֐ݒ肷.
	 *  @param frame
	 */
	@Override
	public void setGrepTab(SearchApp frame) {
		// TODO ꂽ\bhEX^u
		gTab = frame.getGrepTab();
	}

}

/**
 * JTablẽZ`
 * uevŃL[[hAt@CƂɃobNJ[t.
 * @author Yuu
 *
 */
class TextFieldCellRenderer  extends DefaultTableCellRenderer{

	/** L[[hFeLXgtB[h. */
	TextFieldHighlighter textf;

	/** GREP͒l */
	private String grepStr = "";

	/** GREP啶l */
	private boolean grepMojiBool;

	/** s̐F. */
	//private static final Color ROW_COLOR = new Color(210, 225, 230);
	private static final Color ROW_COLOR = new Color(218, 211, 184);

	/** e[ũf[^. */
	private DefaultTableModel dfTable;

	/**
	 * \e[ũf[^𓾂.
	 * @param table   e[ũf[^Zbg
	 */
	public void setdfTable(DefaultTableModel table) {
		this.dfTable = table;
	}

	/**
	 * ʃe[uփ[U[͂GREPۑ.
	 *
	 * @param grepStr GREP
	 */
	public void setGrepStr(String grepStr) {
		this.grepStr = grepStr;
	}

	/**
	 * ʃe[uGREPԂ.
	 * @return
	 */
	public String getGrepStr() {
		return this.grepStr;
	}

	/**
	 * ʃe[uGREP啶lۑ.
	 * @return
	 */
	public void setGrepMojiBool(boolean bool) {
		this.grepMojiBool = bool;
	}

	@Override
	public Component getTableCellRendererComponent(JTable table, Object value,
			boolean isSelected, boolean hasFocus, int row, int column) {
		// TODO ꂽ\bhEX^u
		super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);

		Component com = null;
		String valueStr = (String) value;

		/* pX񂩂t@C̃pX(tpX)𓾂 */
		String pathStr = (String) dfTable.getValueAt(row, 1);

		/* ̍ŌォF̏𓾂Ă */
		String iroStr = (String) dfTable.getValueAt(row, 4);

		switch (column) {

		case 0:
			int columnWidth0 = table.getColumnModel().getColumn(0).getWidth();
			textf = new TextFieldHighlighter(grepStr,columnWidth0,grepMojiBool,false);
			textf.setText(valueStr.trim(),pathStr,true);
			com = textf;
			//com = new JLabel(valueStr);
			//com = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
			break;
		case 1:
			//com = new JLabel(valueStr);
			com = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
			break;
		case 2:
			//com = new JLabel(valueStr);
			com = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
			break;
		case 3:
			int columnWidth3 = table.getColumnModel().getColumn(3).getWidth();
			textf = new TextFieldHighlighter(grepStr,columnWidth3,grepMojiBool,true);
			textf.setText(valueStr.trim(),false);
			//textf.setHighlight(GrepTab.grepFileCombB.getSelectedItem().toString());
			//System.out.println("Ă" + GrepTab.grepFileCombB.getSelectedItem().toString());
			com = textf;
			break;
		case 4:
			//com = new JLabel(valueStr);
			com = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
			break;
		}

		if (isSelected) {
			com.setForeground(UIManager.getColor("Table.selectionForeground"));
			com.setBackground(UIManager.getColor("Table.selectionBackground"));
		} else {
			com.setForeground(UIManager.getColor("Table.foreground"));
			/* sɐFt */
			com.setBackground( (iroStr.equals(GrepTaskWorker.SET_COLOR ) ) ?  UIManager.getColor("Table.background") : ROW_COLOR);
			//com.setBackground( UIManager.getColor("Table.background"));
		}
		//		if (hasFocus) {
		//		com.setForeground(UIManager.getColor("Table.focusCellForeground"));
		//		com.setBackground(UIManager.getColor("Table.focusCellBackground"));
		//		//com.setBounds(r)
		//		}

		return com;

	}

}
