/*Copyright (C) 2011  Yuu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.Color;
import java.awt.Component;
import java.awt.Desktop;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JTable;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.event.MouseInputAdapter;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;


/**
 * t@CAtH_ ^uʂ̌ʕ\e[u
 * @ut@CApXAt@C̃TCYAgqAt@C̕ύXv 6  F͕\Ȃ
 * t@C@t@CpX@̓L[[h\
 * @author Yuu
 */
public class TableResultFile  extends JTable implements ITableResult{

	/** e[ũf[^. */
	private DefaultTableModel dfTable;

	/** JTable̗. */
	final static String[] strColum ={"t@C","pX","TCY oCg","gq","ύX","F"};
	/** JTable̒l. */
	static String[][] strTable = new String[0][];

	/** e[u̗̕\ݒ */
	private TableColumn column;

	/** e[ũZ̕`. */
	private TextFieldCellRendererFile txtfCellRendFile;

	/** xgpǂ. */
	private boolean chkflg = false;

	/** vOXo[ɕ\. */
	public String progresBarStr = new String();

	/** ENbNp̃|bvAbvj[. */
	private final JPopupMenu mouseMenu;
	/** pXRs[j[. */
	private JMenuItem pathItem;
	/** eRs[j[. */
	private JMenuItem naiyouItem;
	/** Jj[. */
	private JMenuItem openItem;
	/** t@C̏ꏊJj[. */
	private JMenuItem openFoldItem;
	/** pXGREP̏ꏊɐݒ肷郁j[. */
	private JMenuItem setGrepItem;

	/** Nbv{[h. */
	//Clipboard clipboard;
	//StringSelection selection;

	/** t@CJŎgp. */
	Desktop desktop = Desktop.getDesktop();

	/** GrepTabNX. */
	private GrepTab gTab;


	TableResultFile() {

		/*******}EXENbÑ|bvAbvj[**********************/
		mouseMenu = new JPopupMenu();
		pathItem = new JMenuItem("pXRs[");
		naiyouItem = new JMenuItem("t@CRs[");
		openItem = new JMenuItem("t@CJ");
		openFoldItem = new JMenuItem("t@C̏ꏊJ");
		setGrepItem = new JMenuItem("t@C̃pXGREPpX̏ꏊɐݒ肷");

		mouseMenu.add(pathItem);
		mouseMenu.addSeparator();
		mouseMenu.add(naiyouItem);
		mouseMenu.addSeparator();
		mouseMenu.add(openItem);	
		mouseMenu.addSeparator();
		mouseMenu.add(openFoldItem);	
		mouseMenu.addSeparator();
		mouseMenu.add(setGrepItem);	
		/*******}EXENbÑ|bvAbvj[**********************/

		/* e[ũf[^Zbg */
		dfTable = new DefaultTableModel ();
		setModel(dfTable);
		/* e[u̗ݒ */
		setDfTableData(strColum, strTable);

		txtfCellRendFile = new TextFieldCellRendererFile();
		/* e[ũf[^ւ̎Q(F݂ɕ\ȂǂŎgp) */
		txtfCellRendFile.setdfTable(dfTable);
		/* e[ũZ̕`Zbg */
		setDefaultRenderer(Object.class, txtfCellRendFile);	

		/* Z̍ݒ */
		setRowHeight(22);

		/** |bvAbvj[\Cxg. */
		final TableResultFile tb = this;
		this.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {

				/** ENbN */
				if (SwingUtilities.isRightMouseButton(e)) {

					int col = tb.columnAtPoint(new Point(e.getX(), e.getY()));
					int row = tb.rowAtPoint(new Point(e.getX(), e.getY()));
					tb.setRowSelectionInterval(row, row);

					/* |bvAbvj[\ */
					mouseMenu.show( tb, e.getX(),e.getY());
					pathItem.setVisible(true);

				}else{
					/* |bvAbvj[\ */
					mouseMenu.setVisible(false);
				}	

			}
		});

		/**  |bvAbvj[@pXRs[.       */
		pathItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int colum = tb.getSelectedColumn();
				int row = tb.getSelectedRow();
				String str = (String) getDfTable().getValueAt(row, 1);

				/* Nbv{[hփpXRs[ */
				SearchApp.clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
				SearchApp.selection = new StringSelection(str);
				SearchApp.clipboard.setContents(SearchApp.selection, null);
			}
		});

		/**  |bvAbvj[@t@CRs[.       */
		naiyouItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int row = tb.getSelectedRow();
				String str = (String) getDfTable().getValueAt(row, 0);

				/* Nbv{[hփpXRs[ */
				SearchApp.clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
				SearchApp.selection = new StringSelection(str);
				SearchApp.clipboard.setContents(SearchApp.selection, null);
			}
		});

		/** |bvAbvj[@t@CJ. */
		openItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int row = tb.getSelectedRow();
				/* t@C̃pX𓾂 */
				String str = (String) getDfTable().getValueAt(row, 1);
				File file = new File(str);

				try {
					/* OSɊ֘AtꂽAvP[VŊJ*/
					desktop.open(file);
				} catch (IOException e1) {
					// TODO ꂽ catch ubN
					e1.printStackTrace();
					SearchApp.showMessage("֘AtꂽAvP[V݂ȂA܂");
				} catch (Exception e2) {
					// TODO ꂽ catch ubN
					e2.printStackTrace();
					SearchApp.showMessage("֘AtꂽAvP[V݂ȂA܂"
							+ SearchApp.crlf + "pXmFĂB");
				}

			}
		});

		/** |bvAbvj[@t@C̏ꏊJ. */
		openFoldItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int row = tb.getSelectedRow();
				/* \Ăe[ut@C̃pX𓾂 */
				String str = (String) getDfTable().getValueAt(row, 1);
				File file = new File(str);

				try {
					/* tH_[OSł̃t@C}l[W[ŊJ*/
					desktop.open(file.getParentFile());
				} catch (IOException e1) {
					// TODO ꂽ catch ubN
					e1.printStackTrace();
					SearchApp.showMessage("tH_J܂BpXmFĂB");
				} catch (Exception e2) {
					// TODO ꂽ catch ubN
					e2.printStackTrace();
					SearchApp.showMessage("tH_J܂BpXmFĂB");
				}
			}
		});

		/** GREP^ũpX͂̏ꏊɒlݒ肷. */
		setGrepItem.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int colum = tb.getSelectedColumn();
				int row = tb.getSelectedRow();
				String str = (String) getDfTable().getValueAt(row, 1);

				/** GREPʂ̃pXꏊ̏ꏊɒlݒ */
				/* ݑIĂl𓾂. */	
				String pathCombStr = (String)gTab.pathCombB.getSelectedItem();
				/* t@C̃pXJComboBoxŒl͂ĂȂꍇƓlł͂ȂꍇɃNbNpXlǉ */
				if ( pathCombStr.equals("") || !pathCombStr.equals(str) ) {
					gTab.pathCombB.insertItemAt(str,0);		  
					gTab.pathCombB.setSelectedIndex(0);
				}
			}
		});
		
		/** }EXړCxg. */
		 this.addMouseMotionListener(new MouseInputAdapter() {
			 public void mouseMoved(MouseEvent e) {
				 /* [XV */
				SearchApp.taskProBarGc.setString(SearchApp.getMemInfo());
				SearchApp.taskProBarGc.setValue((int)SearchApp.meminfoGC);
			   }
		 });		

		/* e[u\f[^́uFv̗TableColumn𓾂 */
		TableColumnModel columnModel = (DefaultTableColumnModel)this.getColumnModel();
		TableColumn column = columnModel.getColumn(5);
		/* uFv̗\ɂ */
		this.removeColumn(column);
	}


	public String getProgresBarStr() {

		return progresBarStr;
	}

	public void setProgressBarStr(String pstr) {
		progresBarStr = pstr;
	}


	/**
	 * ʃe[uփ[U[͂ۑĂ.
	 * 
	 * @param SearchStrm 
	 */
	public void setSearchStr(String SearchStrm) {
		txtfCellRendFile.setSearchStr(SearchStrm);
	}

	/**
	 * Ԃ.
	 * @return
	 */
	public String getSearchStr() {
		return txtfCellRendFile.getSearchStr();
	}

	/**
	 * 啶lۑ.
	 * @return
	 */		
	public void setMojiBool(boolean bool){
		txtfCellRendFile.setMojiBool(bool);
	}

	/**
	 * ̃e[uxłgꂽmF.
	 * @return gpĂꍇ true  gṕ@folse
	 */
	public boolean getChkFlg(){
		return chkflg;
	}


	/**
	 * ̃e[u̎gptOtrueɕύX.
	 * @param flg gpꂽ@true
	 */
	public void setChkFlg(boolean flg){
		chkflg = flg;
	}

	/**
	 * e[ũf[^ get\bh.
	 * @return   e[ũf[^
	 */
	public DefaultTableModel getDfTable() {
		return dfTable;
	}

	/**
	 * e[u̒l̃f[^(ArrayList)ɂ.
	 * @param arrData   e[u̒ľƂȂRNV
	 */
	public void setDfTableData(ArrayList arrData) {

		/* ArrayList̕ԂlPԖڂJString^̔zŎ */
		String[] column = (String[])arrData.get(0);
		/* ArrayList̕Ԃl2ԖڂArrayList^(e[ũf[^) */
		ArrayList tempArr = (ArrayList)arrData.get(1);
		/* ArrayList^̃f[^Object^̂Qz */
		Object[][] ob = (Object[][])tempArr.toArray(new Object[tempArr.size()][]);

		//dfTable = new DefaultTableModel(ob,column);
		dfTable.setDataVector(ob, column);

		setAutoResizeMode( JTable.AUTO_RESIZE_OFF );
		/* ̕ݒ */
		setRowWidth();

	}

	/**
	 * e[u̒lArraylist e[ũ̗^CgzŎ󂯎쐬.
	 * @param arrData   e[u̒l
	 * @param strColum  e[u̗l
	 */
	public void setDfTableDate(ArrayList arrData,String[] strColum) {

		/* ArrayList^̃f[^Object^̂Qz */
		Object[][] ob = (Object[][])arrData.toArray(new Object[arrData.size()][]);

		//dfTable = new DefaultTableModel(ob,column);
		dfTable.setDataVector(ob, strColum); 

		setAutoResizeMode( JTable.AUTO_RESIZE_OFF );
		/* ̕ݒ */
		setRowWidth();
	}

	/**
	 * e[u̒lzŎ󂯎쐬. 
	 * @param column   e[ũJ.
	 * @param ob          e[u̒l.
	 * 
	 * */
	public void setDfTableData(String[] column,Object[][] ob) {
		/* JString^zŐݒAJTable̒l񎟌zŐݒ */
		dfTable.setDataVector(ob, column);

		setAutoResizeMode( JTable.AUTO_RESIZE_OFF );
		/* ̕ݒ */
		setRowWidth();
	}

	/**
	 * zŒl󂯎e[uɍsǉ.
	 * @param strRow
	 */
	public void addTableRow(String strRow[]) {
		//int row = dfTable.getRowCount();
		dfTable.addRow(strRow);
		//TextFieldHighlighter tfhr = (TextFieldHighlighter)this.getDefaultEditor(getColumnClass(3));
		//System.out.println(tfhr);
		//tfhr.setHighlight(GrepTab.grepFileCombB.getSelectedItem().toString());
	}


	/**
	 * e[u̒lׂč폜.
	 */
	public void resetDfTableData() {
		Object[][] ob = new Object[0][];
		String[] str = new String[0];
		this.dfTable.setDataVector(ob,str);

		setAutoResizeMode( JTable.AUTO_RESIZE_OFF );
		/* ̕ݒ */
		setRowWidth();
	}


	/**
	 * e[u̍s폜.
	 */
	public void resetRow() {

		Object[][] ob = new Object[0][];
		dfTable.setDataVector(ob,strColum);

		setAutoResizeMode( JTable.AUTO_RESIZE_OFF );
		/* ̕ݒ */
		setRowWidth();
	}


	/**
	 * GrepTabNX̃IuWFNgϐgTab֐ݒ肷.
	 * @param frame
	 */
	public void setGrepTab(SearchApp frame) {
		gTab = frame.getGrepTab();
	}

	//	/* ( Javadoc)
	//	* eXg
	//	* @see javax.swing.JTable#getCellEditor(int, int)
	//	*/
	//	@Override
	//	public TableCellEditor getCellEditor(int row, int column) { 
	//	Object value = super.getValueAt(row, column);

	//	if(value != null) { 
	//	if(value instanceof TextFieldHighlighter) {
	//	return new DefaultCellEditor((TextFieldHighlighter)value);

	//	}             

	//	return getDefaultEditor(value.getClass()); 

	//	}

	//	return super.getCellEditor(row, column);

	//	} 

	/**
	 * e[u̗̕ݒ
	 */
	public void setRowWidth() {

		for (int i = 0; i < strColum.length; i++) {
			column = getTableHeader().getColumnModel().getColumn(i);
			switch (i) {
			case 0:
				column.setPreferredWidth(150);
				//column.setMaxWidth(100);
				//column.setMinWidth(100);
				//getColumnModel().getColumn(i).sizeWidthToFit();
				break;
			case 1:
				//column.setMaxWidth(80);
				//column.setMinWidth(80);
				//getColumnModel().getColumn(i).sizeWidthToFit();
				column.setPreferredWidth(200);
				break;
			case 2:
				//column.setMaxWidth(50);
				//column.setMinWidth(50);
				//getColumnModel().getColumn(i).sizeWidthToFit();
				column.setPreferredWidth(70);
				break;
			case 3:
				//column.setMaxWidth(250);
				//column.setMinWidth(250);
				//getColumnModel().getColumn(i).sizeWidthToFit();
				//column.setCellEditor(new TextFieldCellRenderer(new TextFieldHighlighter()));
				column.setPreferredWidth(70);
				break;
			case 4:
				column.setPreferredWidth(100);
				break;
			}

		}
	}
}

/**
 * JTablẽZ`
 * t@C(0Ԗڂ̗)ApX(1Ԗڂ̗) ̗ŃL[[h.
 * @author Yuu
 *
 */
class TextFieldCellRendererFile  extends DefaultTableCellRenderer{

	/** L[[hFeLXgtB[h. */
	TextFieldHighlighter textf;

	/** ͒l */
	private String searchStr = "";

	/** 啶l */
	private boolean mojiBool;

	/** s̐F. */
	private static final Color ROW_COLOR = new Color(252, 251, 239);
	//private static final Color ROW_COLOR = new Color(218, 211, 184);

	/** e[ũf[^. */
	private DefaultTableModel dfTable;

	/**
	 * \e[ũf[^𓾂.
	 * @param table   e[ũf[^Zbg
	 */
	public void setdfTable(DefaultTableModel table) {
		this.dfTable = table;
	}

	/**
	 * ʃe[uփ[U[͂ۑ.
	 * @param fileStr 
	 */
	public void setSearchStr(String searchStr) {
		this.searchStr = searchStr;
	}

	/**
	 * ʃe[u猟Ԃ.
	 * @return
	 */	
	public String getSearchStr() {
		return this.searchStr;
	}

	/**
	 * ʃe[u猟啶lۑ.
	 * @return
	 */	
	public void setMojiBool(boolean bool) {
		this.mojiBool = bool;
	}

	@Override
	public Component getTableCellRendererComponent(JTable table, Object value,
			boolean isSelected, boolean hasFocus, int row, int column) {
		// TODO ꂽ\bhEX^u
		super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);

		Component com = null;
		/** Zɕ\eLXg. */
		String valueStr = (String) value;

		/* pX񂩂t@C̃pX𓾂 */
		String pathStr = (String) dfTable.getValueAt(row, 1);

		switch (column) {

		case 0:
			int columnWidth0 = table.getColumnModel().getColumn(0).getWidth();
			textf = new TextFieldHighlighter(searchStr,columnWidth0,mojiBool,true);
			textf.setText(valueStr.trim(),pathStr,true);
			com = textf;
			break;
		case 1:
			int columnWidth1 = table.getColumnModel().getColumn(1).getWidth();
			textf = new TextFieldHighlighter(searchStr,columnWidth1,mojiBool,true);
			textf.setText(valueStr.trim(),false);
			com = textf;
			break;
		case 2:	   
			com = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
			break;
		case 3:
			com = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
			break;
		case 4:   
			com = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
			break;
		}

		if (isSelected) {
			com.setForeground(UIManager.getColor("Table.selectionForeground"));
			com.setBackground(UIManager.getColor("Table.selectionBackground"));
		} else {
			com.setForeground(UIManager.getColor("Table.foreground"));
			/* sɐFt */
			//com.setBackground( (iroStr.equals(FileSearchTaskWorker.SET_COLOR ) ) ?  UIManager.getColor("Table.background") : ROW_COLOR);
			//com.setBackground( UIManager.getColor("Table.background"));
			/* obNOEhJ[ */
			com.setBackground(ROW_COLOR);
		} 
		//		if (hasFocus) {
		//		com.setForeground(UIManager.getColor("Table.focusCellForeground"));
		//		com.setBackground(UIManager.getColor("Table.focusCellBackground"));
		//		//com.setBounds(r)
		//		}

		return com;

	}

}
